!== Open GT_VARIABLE of dimension by dimord
!
! Authors::   Yasuhiro MORIKAWA, Eizi TOYODA
! Version::   $Id: gtvaropenbydimord.f90,v 1.4 2006/01/15 13:10:57 morikawa Exp $
! Tag Name::  $Name: gt4f90io-20060121-3 $
! Copyright:: Copyright (C) GFD Dennou Club, 2000-2005. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
! ʲΥ֥롼, ؿ gtdata_generic 󶡤ޤ
!

subroutine GTVarOpenByDimOrd(var, source_var, dimord, count_compact, err)
  !
  !== gtool4 ǡΥץ
  !
  ! ˳줿ѿ *source_var*  *dimord* ܤμˤѿ
  !  var ˳Ǽޤ *dimord* ϸߤϰϤ
  ! ˤʤäƤ (ѥȲƤ) Ф
  ! Ǥ*count_compact*  <tt>.true.</tt>ꤹ
  ! ٤ƤμΤʤνˤʤޤ
  !
  ! Open 줿ѿɬ Close ʤФʤޤ
  !
  ! *dimord* == 0 ξѿΤٳޤϻȥ󥿤
  ! äʤǤ
  !
  ! *Open*  2 ĤΥ֥롼̾Ǥꡢ
  ! ѿ URL ľܻꤹ뤳ȤǳȤǽǤ
  ! Υ֥롼򻲾Ȥ
  !
  !=== ­
  !
  ! ѿ URL ˥ե̾ꤷʤ硢gtool.nc ǤȤߤʤޤ
  !
  ! ѿ URL ˥ե̾ꤷ硢ѿϰʲε§
  ! 򤵤ޤ
  !
  ! * ѿ򤵤ʤ
  ! * ʤ٤줿ѿ򤵤
  !
  use gtdata_types, only: GT_VARIABLE
  use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory, &
    & map_dup, map_create, map_lookup, gt_dimmap, &
    & map_set, dimord_skip_compact
  use an_generic, only: Open, an_variable, inquire
  use gtdata_generic, only: gt_open => open
  use dc_trace, only: beginsub, endsub, DbgMessage
  use dc_string, only: var_str
  use dc_error
  implicit none
  type(GT_VARIABLE), intent(out):: var
  type(GT_VARIABLE), intent(in):: source_var
  integer, intent(in):: dimord
  logical, intent(in), optional:: count_compact
  logical, intent(out), optional:: err
  integer:: sclass, scid, ld, sndims, stat, udimord, idimord
  type(an_variable):: an
  type(gt_dimmap), allocatable:: map_src(:)
  type(gt_dimmap):: map_result(1)
  logical:: cnt_compact
continue
  call beginsub('gtvaropen-by-dimord', 'var.mapid=%d dimord=%d', &
    & i=(/source_var%mapid, dimord/))

  ! ѿ켫Τ򳫤ľ
  if (dimord == 0) then
    call map_dup(var, source_var)
    if (present(err)) err = .false.
    call endsub('gtvaropen-by-dimord', 'dup')
    return
  endif

  ! ɽdimord  (count_compact ) μѿ
  ! ֹĴ٤롣
  call map_lookup(source_var, ndims=sndims)
  if (sndims <= 0 .or. dimord > sndims) then
    stat = gt_enomoredims
    goto 999
  endif
  allocate(map_src(sndims))
  call map_lookup(source_var, map=map_src)
  cnt_compact = .false.
  if (present(count_compact)) cnt_compact = count_compact
  if (cnt_compact) then
    udimord = dimord
  else
    udimord = dimord_skip_compact(dimord, map=map_src)
  endif
  if (udimord <= 0 .or. udimord > size(map_src)) then
    stat = gt_enomoredims
    goto 999
  endif

  idimord = map_src(udimord)%dimno
  if (idimord < 1) then
    call gt_open(var, map_src(udimord)%url, err=err)
    ! storeerror ϤʤƤ褤
    deallocate(map_src)
    goto 1000
  endif

  ! ּ̤˹碌ּѿץ׽
  call var_class(source_var, sclass, scid)
  if (sclass == vtb_class_netcdf) then
    call Open(an, an_variable(scid), idimord, err)
    call inquire(an, dimlen=ld)
    call map_create(var, vtb_class_netcdf, an%id, 1, (/ld/))
    call map_lookup(var, map=map_result)
    map_result(1)%offset = map_src(udimord)%offset
    map_result(1)%step = map_src(udimord)%step
    map_result(1)%allcount = map_src(udimord)%allcount
    map_result(1)%start = map_src(udimord)%start
    map_result(1)%count = map_src(udimord)%count
    map_result(1)%stride = map_src(udimord)%stride
    call map_set(var, map=map_result, stat=stat)
  else if (sclass == vtb_class_memory) then
    var = source_var
    stat = dc_noerr
  else
    stat = gt_efake
  endif

  deallocate(map_src)
999 continue
  call StoreError(stat, "gtvaropen-by-dimord", cause_i=dimord)
1000 continue
  call endsub('gtvaropen-by-dimord', 'result_var=%d', i=(/var%mapid/))
end subroutine GTVarOpenByDimOrd
